'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function () {
  return {
    visitor: {
      MemberExpression: function MemberExpression(path, state) {
        var node = path.node;
        var property = node.property;

        var name = '';
        if (property.name === 'isNil' && path.parentPath.type !== 'CallExpression') {
          (function () {
            var object = (0, _flat2.default)(node);
            Object.keys(object).forEach(function (key) {
              if (/.type$/.test(key)) {
                if (object[key] === 'ThisExpression') {
                  name += 'this.';
                }
              }
              if (/.name$/.test(key)) {
                if (!/arguments/.test(key) && object[key] !== 'isNil') {
                  name += object[key] + '.';
                }
              }
            });
            name = name.replace(/.$/, '');
            var isArray = (0, _lodash2.default)(node, 'object.computed', false);
            var parentObject = (0, _lodash2.default)(path, 'parentPath.node.expression.object');
            var type = (0, _lodash2.default)(parentObject, 'type');
            var args = (0, _lodash2.default)(parentObject, 'arguments');
            if (isArray) {
              if (node.object.property.name && node.object.computed === true) {
                name = name.replace('.' + node.object.property.name, '');
              }
              var value = (0, _lodash2.default)(node, 'object.property.extra.raw', null) || (0, _lodash2.default)(node, 'object.property.name', null);
              if (value) {
                name += '[' + value + ']';
              }
            } else if (type === 'CallExpression') {
              name += '(';
              if (args !== void 0) {
                args.forEach(function (arg) {
                  name += arg.name;
                  name += ',';
                });
                name = name.replace(/,$/, '');
              }
              name += ')';
            }

            var isNilWrapper = addIsNilHelper.call(state.file).name;

            /* eslint no-void: 0 */
            path.replaceWithSourceString(isNilWrapper + '(' + name + ')');
          })();
        }
      }
    }
  };
};

var _flat = require('flat');

var _flat2 = _interopRequireDefault(_flat);

var _lodash = require('lodash.get');

var _lodash2 = _interopRequireDefault(_lodash);

var _babelTemplate = require('babel-template');

var _babelTemplate2 = _interopRequireDefault(_babelTemplate);

var _babelTypes = require('babel-types');

var t = _interopRequireWildcard(_babelTypes);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var isNilWrapper = (0, _babelTemplate2.default)('(function (val) { return val === null || typeof val === \'undefined\' })()');

function addIsNilHelper() {
  // Modified from https://github.com/babel/babel/blob/master/packages/babel-core/src/transformation/file/index.js#L280
  var name = 'isNilWrapper';

  var declar = this.declarations[name];
  if (declar) {
    return declar;
  }

  if (!this.usedHelpers[name]) {
    this.metadata.usedHelpers.push(name);
    this.usedHelpers[name] = true;
  }

  var generator = this.get('helperGenerator');
  var runtime = this.get('helpersNamespace');

  if (generator) {
    var res = generator(name);

    if (res) {
      return res;
    }
  } else if (runtime) {
    return t.memberExpression(runtime, t.identifier(name));
  }

  var ref = isNilWrapper().expression;
  var uid = this.declarations[name] = this.scope.generateUidIdentifier(name);

  ref._compact = true;
  this.scope.push({
    id: uid,
    init: ref,
    unique: true
  });

  return uid;
}